package cn.com.poc.agent_application.rest.impl;

import java.util.ArrayList;
import java.util.List;
import javax.annotation.Resource;

import cn.com.poc.agent_application.aggregate.AgentApplicationMallService;
import org.springframework.stereotype.Component;
import cn.com.poc.agent_application.rest.BizAgentApplicationMallRest;
import cn.com.poc.agent_application.service.BizAgentApplicationMallService;
import cn.com.poc.agent_application.dto.BizAgentApplicationMallDto;
import cn.com.poc.agent_application.entity.BizAgentApplicationMallEntity;
import cn.com.yict.framemax.data.model.PagingInfo;
import cn.com.poc.agent_application.convert.BizAgentApplicationMallConvert;
import org.springframework.util.Assert;

@Component
public class BizAgentApplicationMallRestImpl implements BizAgentApplicationMallRest {

	@Resource
	private AgentApplicationMallService agentApplicationMallService;
   
   	@Resource
    private BizAgentApplicationMallService bizAgentApplicationMallService;

	@Override
	public BizAgentApplicationMallDto publishAgentToMall(BizAgentApplicationMallDto dto) throws Exception {
		Assert.notNull(dto);
		Assert.notNull(dto.getAgentPublishId());
		Assert.notNull(dto.getAgentType());
		Assert.notNull(dto.getIsCopy());
		return BizAgentApplicationMallConvert.entityToDto(bizAgentApplicationMallService.save(BizAgentApplicationMallConvert.dtoToEntity(dto)));
	}

	public BizAgentApplicationMallDto getById(java.lang.Integer id) throws Exception{
		Assert.notNull(id);
 		return BizAgentApplicationMallConvert.entityToDto(bizAgentApplicationMallService.get(id));
   	}

	@Override
	public List<BizAgentApplicationMallDto> getListByExample(BizAgentApplicationMallDto example, PagingInfo pagingInfo) throws Exception {
		return null;
	}

	public List<BizAgentApplicationMallDto> getList(PagingInfo pagingInfo) throws Exception{
		List<BizAgentApplicationMallDto> resultList = new ArrayList<>();
		List<BizAgentApplicationMallEntity> byExample = bizAgentApplicationMallService.findByExample(pagingInfo);
		for(BizAgentApplicationMallEntity entity : byExample){
			resultList.add(BizAgentApplicationMallConvert.entityToDto(entity));
		}
		return resultList;
   	}
    
	
    public BizAgentApplicationMallDto update(BizAgentApplicationMallDto dto) throws Exception{
		Assert.notNull(dto);
		BizAgentApplicationMallEntity entity = BizAgentApplicationMallConvert.dtoToEntity(dto);
       	return BizAgentApplicationMallConvert.entityToDto(bizAgentApplicationMallService.update(entity));
	}

    public void deletedById(java.lang.Integer id) throws Exception{
		Assert.notNull(id);
		bizAgentApplicationMallService.deletedById(id);
	}

	@Override
	public void collectOrCancelAgentInMall(Integer id) throws Exception {
		agentApplicationMallService.collectOrCancelAgentInMall(id);
	}
}